Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/src/test.cpp	(revision 56)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/src/test.cpp	(revision 69)
@@ -490,57 +576,76 @@
 	  for (uint32_t i=0; i<_param->_nb_bypass_memory; i++)
 	    {
-	      Tcontext_t         context     = rand()% _param->_nb_context;
-	      in_BYPASS_MEMORY_CONTEXT_ID [i]->write(context);
-
-	      Tgeneral_address_t gpr_num_reg = rand()% _param->_nb_general_register;
-	      Tcontrol_t         gpr_val     = (_gpr_val [gpr_num_reg][context]== 0)?((rand()%100) < percent_transaction_bypass):0;
-	      Tgeneral_data_t    gpr_data    = rand()%(1<<_param->_size_general_data);
+	      Tcontext_t         ooo_engine     = rand()% _param->_nb_ooo_engine;
+	      if (_param->_have_port_ooo_engine_id)
+              in_BYPASS_MEMORY_OOO_ENGINE_ID [i]->write(ooo_engine);
+
+	      Tgeneral_address_t num_reg = rand()% _param->_nb_general_register;
+	      Tcontrol_t         val     = (_gpr_val [num_reg][ooo_engine]== 0)?((rand()%100) < percent_transaction_bypass):0;
+	      Tgeneral_data_t    data    = rand()%((1<<_param->_size_general_data)-1);
 	      
-	      in_BYPASS_MEMORY_VAL    [i]->write(gpr_val);	      
-	      in_BYPASS_MEMORY_NUM_REG[i]->write(gpr_num_reg);
-	      in_BYPASS_MEMORY_DATA   [i]->write(gpr_data);
-
-	      if (gpr_val)
+	      val = (val and can_gpr_use [ooo_engine][num_reg] and need_gpr [ooo_engine][num_reg]);
+
+	      in_BYPASS_MEMORY_VAL    [i]->write(val);	      
+	      in_BYPASS_MEMORY_NUM_REG[i]->write(num_reg);
+	      in_BYPASS_MEMORY_DATA   [i]->write(data);
+
+	      if (val)
 		{
-		  LABEL(" * BYPASS_MEMORY ["+toString(i)+"] - gpr["+toString(gpr_num_reg)+"]["+toString(context)+"] <- "+toString(gpr_data));
-		  _gpr     [gpr_num_reg][context] = gpr_data;
-		  _gpr_val [gpr_num_reg][context] = 1;
+		  LABEL(" * BYPASS_MEMORY ["+toString(i)+"] - gpr["+toString(num_reg)+"]["+toString(ooo_engine)+"] <- "+toString(data));
+		  can_gpr_use [ooo_engine][num_reg] = false;
+		  need_gpr [ooo_engine][num_reg] = false;
+
+		  _gpr     [num_reg][ooo_engine] = data;
+		  _gpr_val [num_reg][ooo_engine] = 1;
 		}
 	    }
 	  SC_START(0); // to mealy function
 	  
-// 	  LABEL("Test     RESERVATION_STATION_IN  : "+toString(in_RESERVATION_STATION_IN_VAL->read())+","+toString(out_RESERVATION_STATION_IN_ACK->read()));
-	  if (( in_RESERVATION_STATION_IN_VAL->read() == 1) and
-	      (out_RESERVATION_STATION_IN_ACK->read() == 1))
-	    {
-	      LABEL("Accepted RESERVATION_STATION_IN  n°"+toString(request_in));
+// 	  LABEL("Test     INSERT  : "+toString(in_INSERT_VAL->read())+","+toString(out_INSERT_ACK->read()));
+	  if (( in_INSERT_VAL->read() == 1) and
+	      (out_INSERT_ACK->read() == 1))
+	    {
+	      LABEL("Accepted INSERT  number : "+toString(request_in));
 	      request_in  ++;
 	    }
 
-	  for (uint32_t i=0; i<_param->_size_queue      ; i++)
-	    {
- 	      LABEL("Test     RESERVATION_STATION_OUT "+toString(i)+" : "+toString(out_RESERVATION_STATION_OUT_VAL[i]->read())+","+toString(in_RESERVATION_STATION_OUT_ACK[i]->read()));
-	      if ((out_RESERVATION_STATION_OUT_VAL [i]->read() == 1) and
-		  ( in_RESERVATION_STATION_OUT_ACK [i]->read() == 1))
+	  for (uint32_t i=0; i<_param->_nb_inst_retire; i++)
+	    {
+ 	      LABEL("Test     RETIRE "+toString(i)+" : "+toString(out_RETIRE_VAL[i]->read())+","+toString(in_RETIRE_ACK[i]->read()));
+	      if ((out_RETIRE_VAL [i]->read() == 1) and
+		  ( in_RETIRE_ACK [i]->read() == 1))
 		{
-		  Tpacket_t  packet_id  = out_RESERVATION_STATION_OUT_PACKET_ID [i]->read();
-
-		  LABEL("Accepted RESERVATION_STATION_OUT ["+toString(i)+"] n°"+toString(packet_id)+", request n°"+toString(request_out));
-		  TEST(bool, request_out_wait [packet_id] , true);
+		  Tpacket_t  rob_id;
+		  if (_param->_have_port_rob_id)
+		    rob_id = out_RETIRE_ROB_ID [i]->read();
+		  else
+		    rob_id = 0;
+		  LABEL("Accepted RETIRE ["+toString(i)+"] number : "+toString(rob_id)+", request number : "+toString(request_out));
+		  TEST(bool, request_out_wait [rob_id] , true);
 
 		  request_out ++;
-		  request_out_wait [packet_id] = false;
-
-		  Tcontext_t context_id = _context_id [packet_id];
+		  request_out_wait [rob_id] = false;
+
+		  Tcontext_t ooo_engine_id = _ooo_engine_id [rob_id];
 		  
-		  TEST(Tcontext_t        ,out_RESERVATION_STATION_OUT_CONTEXT_ID[i]->read(),context_id);
-		  if (_read_ra [packet_id])
-		  TEST(Tgeneral_data_t   ,out_RESERVATION_STATION_OUT_DATA_RA   [i]->read(),_gpr[_num_reg_ra[packet_id]][context_id]);
+		  if (_param->_have_port_context_id)
+		  TEST(Tcontext_t        ,out_RETIRE_CONTEXT_ID   [i]->read(),(2*ooo_engine_id)%_param->_nb_context  );
+		  if (_param->_have_port_front_end_id)
+		  TEST(Tcontext_t        ,out_RETIRE_FRONT_END_ID [i]->read(),(3*ooo_engine_id)%_param->_nb_front_end);
+		  if (_param->_have_port_ooo_engine_id)
+		  TEST(Tcontext_t        ,out_RETIRE_OOO_ENGINE_ID[i]->read(),ooo_engine_id);
+
+		  if (_read_ra [rob_id])
+		  TEST(Tgeneral_data_t   ,out_RETIRE_DATA_RA   [i]->read(),_gpr[_num_reg_ra[rob_id]][ooo_engine_id]);
 		  
-		  if (_read_rb [packet_id])
-		  TEST(Tgeneral_data_t   ,out_RESERVATION_STATION_OUT_DATA_RB   [i]->read(),_gpr[_num_reg_rb[packet_id]][context_id]);
+		  if (_read_rb [rob_id])
+		  TEST(Tgeneral_data_t   ,out_RETIRE_DATA_RB   [i]->read(),_gpr[_num_reg_rb[rob_id]][ooo_engine_id]);
 		  
-		  if (_read_rc [packet_id])
-		  TEST(Tspecial_data_t   ,out_RESERVATION_STATION_OUT_DATA_RC   [i]->read(),_spr[_num_reg_rc[packet_id]][context_id]);
+		  if (_read_rc [rob_id])
+		  TEST(Tspecial_data_t   ,out_RETIRE_DATA_RC   [i]->read(),_spr[_num_reg_rc[rob_id]][ooo_engine_id]);
+
+// 		  need_gpr [ooo_engine_id][_num_reg_ra[rob_id]]= true;
+// 		  need_gpr [ooo_engine_id][_num_reg_rb[rob_id]]= true;
+// 		  need_spr [ooo_engine_id][_num_reg_rc[rob_id]]= true;
 		}
 	    }
@@ -561,56 +666,71 @@
   delete     in_NRESET;
 
-  delete     in_RESERVATION_STATION_IN_VAL         ;
-  delete    out_RESERVATION_STATION_IN_ACK         ;
-  delete     in_RESERVATION_STATION_IN_CONTEXT_ID  ;
-  delete     in_RESERVATION_STATION_IN_PACKET_ID   ;
-  delete     in_RESERVATION_STATION_IN_OPERATION   ;
-  delete     in_RESERVATION_STATION_IN_TYPE        ;
-  delete     in_RESERVATION_STATION_IN_HAS_IMMEDIAT;
-  delete     in_RESERVATION_STATION_IN_IMMEDIAT    ;
-//delete     in_RESERVATION_STATION_IN_READ_RA     ;
-  delete     in_RESERVATION_STATION_IN_NUM_REG_RA  ;
-  delete     in_RESERVATION_STATION_IN_DATA_RA_VAL ;
-  delete     in_RESERVATION_STATION_IN_DATA_RA     ;
-//delete     in_RESERVATION_STATION_IN_READ_RB     ;
-  delete     in_RESERVATION_STATION_IN_NUM_REG_RB  ;
-  delete     in_RESERVATION_STATION_IN_DATA_RB_VAL ;
-  delete     in_RESERVATION_STATION_IN_DATA_RB     ;
-//delete     in_RESERVATION_STATION_IN_READ_RC     ;
-  delete     in_RESERVATION_STATION_IN_NUM_REG_RC  ;
-  delete     in_RESERVATION_STATION_IN_DATA_RC_VAL ;
-  delete     in_RESERVATION_STATION_IN_DATA_RC     ;
-  delete     in_RESERVATION_STATION_IN_WRITE_RD    ;
-  delete     in_RESERVATION_STATION_IN_NUM_REG_RD  ;
-  delete     in_RESERVATION_STATION_IN_WRITE_RE    ;
-  delete     in_RESERVATION_STATION_IN_NUM_REG_RE  ;
-  
-  delete [] out_RESERVATION_STATION_OUT_VAL         ;
-  delete []  in_RESERVATION_STATION_OUT_ACK         ;
-  delete [] out_RESERVATION_STATION_OUT_CONTEXT_ID  ;
-  delete [] out_RESERVATION_STATION_OUT_PACKET_ID   ;
-  delete [] out_RESERVATION_STATION_OUT_OPERATION   ;
-  delete [] out_RESERVATION_STATION_OUT_TYPE        ;
-  delete [] out_RESERVATION_STATION_OUT_HAS_IMMEDIAT;
-  delete [] out_RESERVATION_STATION_OUT_IMMEDIAT    ;
-  delete [] out_RESERVATION_STATION_OUT_DATA_RA     ;
-  delete [] out_RESERVATION_STATION_OUT_DATA_RB     ;
-  delete [] out_RESERVATION_STATION_OUT_DATA_RC     ;
-  delete [] out_RESERVATION_STATION_OUT_WRITE_RD    ;
-  delete [] out_RESERVATION_STATION_OUT_NUM_REG_RD  ;
-  delete [] out_RESERVATION_STATION_OUT_WRITE_RE    ;
-  delete [] out_RESERVATION_STATION_OUT_NUM_REG_RE  ;
+  delete     in_INSERT_VAL         ;
+  delete    out_INSERT_ACK         ;
+  if (_param->_have_port_context_id)  
+  delete     in_INSERT_CONTEXT_ID  ;
+  if (_param->_have_port_front_end_id)  
+  delete     in_INSERT_FRONT_END_ID   ;
+  if (_param->_have_port_ooo_engine_id)  
+  delete     in_INSERT_OOO_ENGINE_ID  ;
+  if (_param->_have_port_rob_id)  
+  delete     in_INSERT_ROB_ID      ;
+  delete     in_INSERT_OPERATION   ;
+  delete     in_INSERT_TYPE        ;
+  delete     in_INSERT_HAS_IMMEDIAT;
+  delete     in_INSERT_IMMEDIAT    ;
+//delete     in_INSERT_READ_RA     ;
+  delete     in_INSERT_NUM_REG_RA  ;
+  delete     in_INSERT_DATA_RA_VAL ;
+  delete     in_INSERT_DATA_RA     ;
+//delete     in_INSERT_READ_RB     ;
+  delete     in_INSERT_NUM_REG_RB  ;
+  delete     in_INSERT_DATA_RB_VAL ;
+  delete     in_INSERT_DATA_RB     ;
+//delete     in_INSERT_READ_RC     ;
+  delete     in_INSERT_NUM_REG_RC  ;
+  delete     in_INSERT_DATA_RC_VAL ;
+  delete     in_INSERT_DATA_RC     ;
+  delete     in_INSERT_WRITE_RD    ;
+  delete     in_INSERT_NUM_REG_RD  ;
+  delete     in_INSERT_WRITE_RE    ;
+  delete     in_INSERT_NUM_REG_RE  ;
+  
+  delete [] out_RETIRE_VAL         ;
+  delete []  in_RETIRE_ACK         ;
+  if (_param->_have_port_context_id)  
+  delete [] out_RETIRE_CONTEXT_ID  ;
+  if (_param->_have_port_front_end_id)  
+  delete [] out_RETIRE_FRONT_END_ID;
+  if (_param->_have_port_ooo_engine_id)  
+  delete [] out_RETIRE_OOO_ENGINE_ID  ;
+  if (_param->_have_port_rob_id)  
+  delete [] out_RETIRE_ROB_ID   ;
+  delete [] out_RETIRE_OPERATION   ;
+  delete [] out_RETIRE_TYPE        ;
+  delete [] out_RETIRE_HAS_IMMEDIAT;
+  delete [] out_RETIRE_IMMEDIAT    ;
+  delete [] out_RETIRE_DATA_RA     ;
+  delete [] out_RETIRE_DATA_RB     ;
+  delete [] out_RETIRE_DATA_RC     ;
+  delete [] out_RETIRE_WRITE_RD    ;
+  delete [] out_RETIRE_NUM_REG_RD  ;
+  delete [] out_RETIRE_WRITE_RE    ;
+  delete [] out_RETIRE_NUM_REG_RE  ;
   
   delete []  in_GPR_WRITE_VAL       ;
-  delete []  in_GPR_WRITE_CONTEXT_ID;
+  if (_param->_have_port_ooo_engine_id)  
+  delete []  in_GPR_WRITE_OOO_ENGINE_ID;
   delete []  in_GPR_WRITE_NUM_REG   ;
   delete []  in_GPR_WRITE_DATA      ;
   
   delete []  in_SPR_WRITE_VAL       ;
-  delete []  in_SPR_WRITE_CONTEXT_ID;
+  if (_param->_have_port_ooo_engine_id)  
+  delete []  in_SPR_WRITE_OOO_ENGINE_ID;
   delete []  in_SPR_WRITE_NUM_REG   ;
   delete []  in_SPR_WRITE_DATA      ;
   
-  delete []  in_BYPASS_WRITE_CONTEXT_ID ;
+  if (_param->_have_port_ooo_engine_id)  
+  delete []  in_BYPASS_WRITE_OOO_ENGINE_ID ;
   delete []  in_BYPASS_WRITE_GPR_VAL    ;
   delete []  in_BYPASS_WRITE_GPR_NUM_REG;
@@ -621,5 +741,6 @@
   
   delete []  in_BYPASS_MEMORY_VAL       ;
-  delete []  in_BYPASS_MEMORY_CONTEXT_ID;
+  if (_param->_have_port_ooo_engine_id)  
+  delete []  in_BYPASS_MEMORY_OOO_ENGINE_ID;
   delete []  in_BYPASS_MEMORY_NUM_REG   ;
   delete []  in_BYPASS_MEMORY_DATA      ;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Parameters.h	(revision 56)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Parameters.h	(revision 69)
@@ -27,5 +27,8 @@
     //-----[ fields ]------------------------------------------------------------
   public : const uint32_t    _size_queue           ;
+  public : const uint32_t    _nb_inst_retire       ;
   public : const uint32_t    _nb_context           ;
+  public : const uint32_t    _nb_front_end         ;
+  public : const uint32_t    _nb_ooo_engine        ;
   public : const uint32_t    _nb_packet            ;
   public : const uint32_t    _size_general_data    ;
@@ -48,5 +51,7 @@
     */
   public : const uint32_t    _size_context_id      ;
-  public : const uint32_t    _size_packet_id       ;
+  public : const uint32_t    _size_front_end_id    ;
+  public : const uint32_t    _size_ooo_engine_id   ;
+  public : const uint32_t    _size_rob_id          ;
   public : const uint32_t    _size_general_register;
   public : const uint32_t    _size_special_register;
@@ -54,7 +59,15 @@
   public : const uint32_t    _size_type            ;
 
+  public : const bool        _have_port_context_id   ;
+  public : const bool        _have_port_front_end_id ;
+  public : const bool        _have_port_ooo_engine_id;
+  public : const bool        _have_port_rob_id       ;
+
     //-----[ methods ]-----------------------------------------------------------
   public : Parameters  (uint32_t size_queue         ,
+			uint32_t nb_inst_retire     ,
 			uint32_t nb_context         ,
+			uint32_t nb_front_end       ,
+			uint32_t nb_ooo_engine      ,
 			uint32_t nb_packet          ,
 			uint32_t size_general_data  ,
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Reservation_station.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Reservation_station.h	(revision 56)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Reservation_station.h	(revision 69)
@@ -17,7 +17,9 @@
 #include "Common/include/Debug.h"
 
+#ifndef  SYSTEMC_VHDL_COMPATIBILITY
 #include "Behavioural/Generic/Queue_Control/include/Queue_Control.h"
+#endif
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Parameters.h"
-#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Types.h"
+#include "Behavioural/include/Types.h"
 #ifdef STATISTICS
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Statistics.h"
@@ -42,6 +44,8 @@
   class Treservation_station_entry_t
   {
-  public    : Tcontext_t         _context_id  ;
-  public    : Tpacket_t          _packet_id   ;
+  public    : Tcontext_t         _context_id     ;
+  public    : Tcontext_t         _front_end_id   ;
+  public    : Tcontext_t         _ooo_engine_id  ;
+  public    : Tpacket_t          _rob_id         ;
   public    : Toperation_t       _operation   ;
   public    : Ttype_t            _type        ;
@@ -68,26 +72,28 @@
 				morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::reservation_station::Treservation_station_entry_t & x)
     {
-      output_stream << " * _context_id  : " << toString(x._context_id  ) << endl
-		    << " * _packet_id   : " << toString(x._packet_id   ) << endl
-		    << " * _operation   : " << toString(x._operation   ) << endl
-		    << " * _type        : " << toString(x._type        ) << endl
-		    << " * _has_immediat: " << toString(x._has_immediat) << endl
-		    << " * _immediat    : " << toString(x._immediat    ) << endl
-// 		    << " * _read_ra     : " << toString(x._read_ra     ) << endl
-		    << " * _num_reg_ra  : " << toString(x._num_reg_ra  ) << endl
-		    << " * _data_ra_val : " << toString(x._data_ra_val ) << endl
-		    << " * _data_ra     : " << toString(x._data_ra     ) << endl
-// 		    << " * _read_rb     : " << toString(x._read_rb     ) << endl
-		    << " * _num_reg_rb  : " << toString(x._num_reg_rb  ) << endl
-		    << " * _data_rb_val : " << toString(x._data_rb_val ) << endl
-		    << " * _data_rb     : " << toString(x._data_rb     ) << endl
-// 		    << " * _read_rc     : " << toString(x._read_rc     ) << endl
-		    << " * _num_reg_rc  : " << toString(x._num_reg_rc  ) << endl
-		    << " * _data_rc_val : " << toString(x._data_rc_val ) << endl
-		    << " * _data_rc     : " << toString(x._data_rc     ) << endl
-		    << " * _write_rd    : " << toString(x._write_rd    ) << endl
-		    << " * _num_reg_rd  : " << toString(x._num_reg_rd  ) << endl
-		    << " * _write_re    : " << toString(x._write_re    ) << endl
-		    << " * _num_reg_re  : " << toString(x._num_reg_re  ) << endl;
+      output_stream << " * _context_id     : " << toString(x._context_id     ) << endl
+		    << " * _front_end_id   : " << toString(x._front_end_id   ) << endl
+		    << " * _ooo_engine_id  : " << toString(x._ooo_engine_id  ) << endl
+		    << " * _rob_id         : " << toString(x._rob_id         ) << endl
+		    << " * _operation      : " << toString(x._operation      ) << endl
+		    << " * _type           : " << toString(x._type           ) << endl
+		    << " * _has_immediat   : " << toString(x._has_immediat   ) << endl
+		    << " * _immediat       : " << toString(x._immediat       ) << endl
+// 		    << " * _read_ra        : " << toString(x._read_ra        ) << endl
+		    << " * _num_reg_ra     : " << toString(x._num_reg_ra     ) << endl
+		    << " * _data_ra_val    : " << toString(x._data_ra_val    ) << endl
+		    << " * _data_ra        : " << toString(x._data_ra        ) << endl
+// 		    << " * _read_rb        : " << toString(x._read_rb        ) << endl
+		    << " * _num_reg_rb     : " << toString(x._num_reg_rb     ) << endl
+		    << " * _data_rb_val    : " << toString(x._data_rb_val    ) << endl
+		    << " * _data_rb        : " << toString(x._data_rb        ) << endl
+// 		    << " * _read_rc        : " << toString(x._read_rc        ) << endl
+		    << " * _num_reg_rc     : " << toString(x._num_reg_rc     ) << endl
+		    << " * _data_rc_val    : " << toString(x._data_rc_val    ) << endl
+		    << " * _data_rc        : " << toString(x._data_rc        ) << endl
+		    << " * _write_rd       : " << toString(x._write_rd       ) << endl
+		    << " * _num_reg_rd     : " << toString(x._num_reg_rd     ) << endl
+		    << " * _write_re       : " << toString(x._write_re       ) << endl
+		    << " * _num_reg_re     : " << toString(x._num_reg_re     ) << endl;
 
       return output_stream;
@@ -123,77 +129,81 @@
   public    : SC_IN (Tcontrol_t)            *  in_NRESET       ;
 
-    // ~~~~~[ Interface "reservation_station_in" ]~~~~~~~~~~~~~~~~~~~~~~~~
-  public    : SC_IN (Tcontrol_t        )    *  in_RESERVATION_STATION_IN_VAL         ;
-  public    : SC_OUT(Tcontrol_t        )    * out_RESERVATION_STATION_IN_ACK         ;
-  public    : SC_IN (Tcontext_t        )    *  in_RESERVATION_STATION_IN_CONTEXT_ID  ;
-  public    : SC_IN (Tpacket_t         )    *  in_RESERVATION_STATION_IN_PACKET_ID   ;
-  public    : SC_IN (Toperation_t      )    *  in_RESERVATION_STATION_IN_OPERATION   ;
-  public    : SC_IN (Ttype_t           )    *  in_RESERVATION_STATION_IN_TYPE        ;
-  public    : SC_IN (Tcontrol_t        )    *  in_RESERVATION_STATION_IN_HAS_IMMEDIAT;
-  public    : SC_IN (Tgeneral_data_t   )    *  in_RESERVATION_STATION_IN_IMMEDIAT    ;
-//public    : SC_IN (Tcontrol_t        )    *  in_RESERVATION_STATION_IN_READ_RA     ;
-  public    : SC_IN (Tgeneral_address_t)    *  in_RESERVATION_STATION_IN_NUM_REG_RA  ;
-  public    : SC_IN (Tcontrol_t        )    *  in_RESERVATION_STATION_IN_DATA_RA_VAL ;
-  public    : SC_IN (Tgeneral_data_t   )    *  in_RESERVATION_STATION_IN_DATA_RA     ;
-//public    : SC_IN (Tcontrol_t        )    *  in_RESERVATION_STATION_IN_READ_RB     ;
-  public    : SC_IN (Tgeneral_address_t)    *  in_RESERVATION_STATION_IN_NUM_REG_RB  ;
-  public    : SC_IN (Tcontrol_t        )    *  in_RESERVATION_STATION_IN_DATA_RB_VAL ;
-  public    : SC_IN (Tgeneral_data_t   )    *  in_RESERVATION_STATION_IN_DATA_RB     ;
-//public    : SC_IN (Tcontrol_t        )    *  in_RESERVATION_STATION_IN_READ_RC     ;
-  public    : SC_IN (Tspecial_address_t)    *  in_RESERVATION_STATION_IN_NUM_REG_RC  ;
-  public    : SC_IN (Tcontrol_t        )    *  in_RESERVATION_STATION_IN_DATA_RC_VAL ;
-  public    : SC_IN (Tspecial_data_t   )    *  in_RESERVATION_STATION_IN_DATA_RC     ;
-  public    : SC_IN (Tcontrol_t        )    *  in_RESERVATION_STATION_IN_WRITE_RD    ;
-  public    : SC_IN (Tgeneral_address_t)    *  in_RESERVATION_STATION_IN_NUM_REG_RD  ;
-  public    : SC_IN (Tcontrol_t        )    *  in_RESERVATION_STATION_IN_WRITE_RE    ;
-  public    : SC_IN (Tspecial_address_t)    *  in_RESERVATION_STATION_IN_NUM_REG_RE  ;
-
-    // ~~~~~[ Interface "reservation_station_out" ]~~~~~~~~~~~~~~~~~~~~~~~
-  public    : SC_OUT(Tcontrol_t        )   ** out_RESERVATION_STATION_OUT_VAL         ;
-  public    : SC_IN (Tcontrol_t        )   **  in_RESERVATION_STATION_OUT_ACK         ;
-  public    : SC_OUT(Tcontext_t        )   ** out_RESERVATION_STATION_OUT_CONTEXT_ID  ;
-  public    : SC_OUT(Tpacket_t         )   ** out_RESERVATION_STATION_OUT_PACKET_ID   ;
-  public    : SC_OUT(Toperation_t      )   ** out_RESERVATION_STATION_OUT_OPERATION   ;
-  public    : SC_OUT(Ttype_t           )   ** out_RESERVATION_STATION_OUT_TYPE        ;
-  public    : SC_OUT(Tcontrol_t        )   ** out_RESERVATION_STATION_OUT_HAS_IMMEDIAT;
-  public    : SC_OUT(Tgeneral_data_t   )   ** out_RESERVATION_STATION_OUT_IMMEDIAT    ;
-  public    : SC_OUT(Tgeneral_data_t   )   ** out_RESERVATION_STATION_OUT_DATA_RA     ;
-  public    : SC_OUT(Tgeneral_data_t   )   ** out_RESERVATION_STATION_OUT_DATA_RB     ;
-  public    : SC_OUT(Tspecial_data_t   )   ** out_RESERVATION_STATION_OUT_DATA_RC     ;
-  public    : SC_OUT(Tcontrol_t        )   ** out_RESERVATION_STATION_OUT_WRITE_RD    ;
-  public    : SC_OUT(Tgeneral_address_t)   ** out_RESERVATION_STATION_OUT_NUM_REG_RD  ;
-  public    : SC_OUT(Tcontrol_t        )   ** out_RESERVATION_STATION_OUT_WRITE_RE    ;
-  public    : SC_OUT(Tspecial_address_t)   ** out_RESERVATION_STATION_OUT_NUM_REG_RE  ;
+    // ~~~~~[ Interface "insert" ]~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_IN (Tcontrol_t        )    *  in_INSERT_VAL            ;
+  public    : SC_OUT(Tcontrol_t        )    * out_INSERT_ACK            ;
+  public    : SC_IN (Tcontext_t        )    *  in_INSERT_CONTEXT_ID     ;
+  public    : SC_IN (Tcontext_t        )    *  in_INSERT_FRONT_END_ID   ;
+  public    : SC_IN (Tcontext_t        )    *  in_INSERT_OOO_ENGINE_ID  ;
+  public    : SC_IN (Tpacket_t         )    *  in_INSERT_ROB_ID         ;
+  public    : SC_IN (Toperation_t      )    *  in_INSERT_OPERATION      ;
+  public    : SC_IN (Ttype_t           )    *  in_INSERT_TYPE           ;
+  public    : SC_IN (Tcontrol_t        )    *  in_INSERT_HAS_IMMEDIAT   ;
+  public    : SC_IN (Tgeneral_data_t   )    *  in_INSERT_IMMEDIAT       ;
+//public    : SC_IN (Tcontrol_t        )    *  in_INSERT_READ_RA        ;
+  public    : SC_IN (Tgeneral_address_t)    *  in_INSERT_NUM_REG_RA     ;
+  public    : SC_IN (Tcontrol_t        )    *  in_INSERT_DATA_RA_VAL    ;
+  public    : SC_IN (Tgeneral_data_t   )    *  in_INSERT_DATA_RA        ;
+//public    : SC_IN (Tcontrol_t        )    *  in_INSERT_READ_RB        ;
+  public    : SC_IN (Tgeneral_address_t)    *  in_INSERT_NUM_REG_RB     ;
+  public    : SC_IN (Tcontrol_t        )    *  in_INSERT_DATA_RB_VAL    ;
+  public    : SC_IN (Tgeneral_data_t   )    *  in_INSERT_DATA_RB        ;
+//public    : SC_IN (Tcontrol_t        )    *  in_INSERT_READ_RC        ;
+  public    : SC_IN (Tspecial_address_t)    *  in_INSERT_NUM_REG_RC     ;
+  public    : SC_IN (Tcontrol_t        )    *  in_INSERT_DATA_RC_VAL    ;
+  public    : SC_IN (Tspecial_data_t   )    *  in_INSERT_DATA_RC        ;
+  public    : SC_IN (Tcontrol_t        )    *  in_INSERT_WRITE_RD       ;
+  public    : SC_IN (Tgeneral_address_t)    *  in_INSERT_NUM_REG_RD     ;
+  public    : SC_IN (Tcontrol_t        )    *  in_INSERT_WRITE_RE       ;
+  public    : SC_IN (Tspecial_address_t)    *  in_INSERT_NUM_REG_RE     ;
+
+    // ~~~~~[ Interface "retire" ]~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_OUT(Tcontrol_t        )   ** out_RETIRE_VAL            ;
+  public    : SC_IN (Tcontrol_t        )   **  in_RETIRE_ACK            ;
+  public    : SC_OUT(Tcontext_t        )   ** out_RETIRE_CONTEXT_ID     ;
+  public    : SC_OUT(Tcontext_t        )   ** out_RETIRE_FRONT_END_ID   ;
+  public    : SC_OUT(Tcontext_t        )   ** out_RETIRE_OOO_ENGINE_ID  ;
+  public    : SC_OUT(Tpacket_t         )   ** out_RETIRE_ROB_ID         ;
+  public    : SC_OUT(Toperation_t      )   ** out_RETIRE_OPERATION      ;
+  public    : SC_OUT(Ttype_t           )   ** out_RETIRE_TYPE           ;
+  public    : SC_OUT(Tcontrol_t        )   ** out_RETIRE_HAS_IMMEDIAT   ;
+  public    : SC_OUT(Tgeneral_data_t   )   ** out_RETIRE_IMMEDIAT       ;
+  public    : SC_OUT(Tgeneral_data_t   )   ** out_RETIRE_DATA_RA        ;
+  public    : SC_OUT(Tgeneral_data_t   )   ** out_RETIRE_DATA_RB        ;
+  public    : SC_OUT(Tspecial_data_t   )   ** out_RETIRE_DATA_RC        ;
+  public    : SC_OUT(Tcontrol_t        )   ** out_RETIRE_WRITE_RD       ;
+  public    : SC_OUT(Tgeneral_address_t)   ** out_RETIRE_NUM_REG_RD     ;
+  public    : SC_OUT(Tcontrol_t        )   ** out_RETIRE_WRITE_RE       ;
+  public    : SC_OUT(Tspecial_address_t)   ** out_RETIRE_NUM_REG_RE     ;
 
     // ~~~~~[ Interface "gpr_write" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-  public    : SC_IN (Tcontrol_t        )   **  in_GPR_WRITE_VAL       ; // val and ack
-  public    : SC_IN (Tcontext_t        )   **  in_GPR_WRITE_CONTEXT_ID;
-  public    : SC_IN (Tgeneral_address_t)   **  in_GPR_WRITE_NUM_REG   ;
-  public    : SC_IN (Tgeneral_data_t   )   **  in_GPR_WRITE_DATA      ;
+  public    : SC_IN (Tcontrol_t        )   **  in_GPR_WRITE_VAL          ; // val and ack
+  public    : SC_IN (Tcontext_t        )   **  in_GPR_WRITE_OOO_ENGINE_ID;
+  public    : SC_IN (Tgeneral_address_t)   **  in_GPR_WRITE_NUM_REG      ;
+  public    : SC_IN (Tgeneral_data_t   )   **  in_GPR_WRITE_DATA         ;
 
     // ~~~~~[ Interface "spr_write" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-  public    : SC_IN (Tcontrol_t        )   **  in_SPR_WRITE_VAL       ; // val and ack
-  public    : SC_IN (Tcontext_t        )   **  in_SPR_WRITE_CONTEXT_ID;
-  public    : SC_IN (Tspecial_address_t)   **  in_SPR_WRITE_NUM_REG   ;
-  public    : SC_IN (Tspecial_data_t   )   **  in_SPR_WRITE_DATA      ;
+  public    : SC_IN (Tcontrol_t        )   **  in_SPR_WRITE_VAL          ; // val and ack
+  public    : SC_IN (Tcontext_t        )   **  in_SPR_WRITE_OOO_ENGINE_ID;
+  public    : SC_IN (Tspecial_address_t)   **  in_SPR_WRITE_NUM_REG      ;
+  public    : SC_IN (Tspecial_data_t   )   **  in_SPR_WRITE_DATA         ;
 
     // ~~~~~[ Interface "bypass_write" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-  public    : SC_IN (Tcontext_t        )   **  in_BYPASS_WRITE_CONTEXT_ID ;
-  public    : SC_IN (Tcontrol_t        )   **  in_BYPASS_WRITE_GPR_VAL    ;
-  public    : SC_IN (Tgeneral_address_t)   **  in_BYPASS_WRITE_GPR_NUM_REG; // RD
-  public    : SC_IN (Tgeneral_data_t   )   **  in_BYPASS_WRITE_GPR_DATA   ;
-  public    : SC_IN (Tcontrol_t        )   **  in_BYPASS_WRITE_SPR_VAL    ;
-  public    : SC_IN (Tspecial_address_t)   **  in_BYPASS_WRITE_SPR_NUM_REG; // RE
-  public    : SC_IN (Tspecial_data_t   )   **  in_BYPASS_WRITE_SPR_DATA   ;
+  public    : SC_IN (Tcontext_t        )   **  in_BYPASS_WRITE_OOO_ENGINE_ID ;
+  public    : SC_IN (Tcontrol_t        )   **  in_BYPASS_WRITE_GPR_VAL       ;
+  public    : SC_IN (Tgeneral_address_t)   **  in_BYPASS_WRITE_GPR_NUM_REG   ; // RD
+  public    : SC_IN (Tgeneral_data_t   )   **  in_BYPASS_WRITE_GPR_DATA      ;
+  public    : SC_IN (Tcontrol_t        )   **  in_BYPASS_WRITE_SPR_VAL       ;
+  public    : SC_IN (Tspecial_address_t)   **  in_BYPASS_WRITE_SPR_NUM_REG   ; // RE
+  public    : SC_IN (Tspecial_data_t   )   **  in_BYPASS_WRITE_SPR_DATA      ;
 
     // ~~~~~[ Interface "bypass_memory" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-  public    : SC_IN (Tcontrol_t        )   **  in_BYPASS_MEMORY_VAL       ;
-  public    : SC_IN (Tcontext_t        )   **  in_BYPASS_MEMORY_CONTEXT_ID;
-  public    : SC_IN (Tgeneral_address_t)   **  in_BYPASS_MEMORY_NUM_REG   ;
-  public    : SC_IN (Tgeneral_data_t   )   **  in_BYPASS_MEMORY_DATA      ;
+  public    : SC_IN (Tcontrol_t        )   **  in_BYPASS_MEMORY_VAL          ;
+  public    : SC_IN (Tcontext_t        )   **  in_BYPASS_MEMORY_OOO_ENGINE_ID;
+  public    : SC_IN (Tgeneral_address_t)   **  in_BYPASS_MEMORY_NUM_REG      ;
+  public    : SC_IN (Tgeneral_data_t   )   **  in_BYPASS_MEMORY_DATA         ;
 
 
@@ -203,9 +213,15 @@
 
     // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#ifdef  SYSTEMC_VHDL_COMPATIBILITY
+  protected : bool                          *  _queue_valid;
+  protected : uint32_t                         internal_INSERT_SLOT;
+#else
   protected : morpheo::behavioural::generic::queue_control::Queue_Control * _queue_control;
+#endif
   protected : Treservation_station_entry_t  *  _queue;
 
-  protected : Tcontrol_t                       internal_RESERVATION_STATION_IN_ACK;
-  protected : Tcontrol_t                    *  internal_RESERVATION_STATION_OUT_VAL;
+  protected : Tcontrol_t                       internal_INSERT_ACK;
+  protected : Tcontrol_t                    *  internal_RETIRE_VAL;
+  protected : uint32_t                      *  internal_RETIRE_SLOT;
 #endif
 
@@ -244,7 +260,5 @@
 #endif					       
 					       
-#ifdef VHDL_TESTBENCH			       
-  private : void     vhdl_testbench_transition (void);
-#endif
+  private : void     end_cycle                 (void);
   };
 
